#ifndef AUDIT_H_INCLUDED
#define AUDIT_H_INCLUDED

#include <libmemcached/memcached.h>
#include <libwebguard-utils/str_t.h>

#define MAX_STR_TIMESTAMP_SIZE (sizeof("-9223372036854775808") - 1)
#define LIMIT_LOG_SIZE 8 * 1024

typedef struct AUDIT_CONTEXT AUDIT_CONTEXT;

AUDIT_CONTEXT* audit_init( const char* config_file, size_t auditor_id, memcached_st* memc );
void audit_deinit( AUDIT_CONTEXT* ctx );
void audit_free( AUDIT_CONTEXT* ctx );
int add_audit_record( AUDIT_CONTEXT* ctx, char* log_serial, size_t log_size );
size_t get_audit_timestamp(void);

/* вынести username_max_len в AUDIT_CONTEXT */
size_t get_audit_username_len( const str_t* username, size_t username_max_len );


#endif // AUDIT_H_INCLUDED
