#ifndef FCGI_SERVER_H_INCLUDED
#define FCGI_SERVER_H_INCLUDED

#ifdef __cplusplus
extern "C"{
#endif

/** Put here definitions of acl_loader fast-cgi protocol interface  */

typedef struct fcgi_server* HFcgi;

typedef enum fcgi_server_state
{
	SERVER_CREATED,
	SERVER_RUNNING,
	SERVER_STOPPED

} fcgi_server_state;

typedef enum fcgi_handler_status
{
	HANDLER_ERROR = -1,
	HANDLER_SUCCESS = 0

} fcgi_handler_status;

typedef fcgi_handler_status (*handler_func)(void* ctx);

typedef struct fcgi_handler
{
	handler_func execute;
	void* ctx;

} fcgi_handler;

typedef struct fcgi_tcp
{
	char* host;
	int port;

} fcgi_tcp;

typedef struct fcgi_conf
{
	fcgi_tcp listen;
	fcgi_handler handler;

} fcgi_conf;

int fcgi_load_server_conf(const char* filename, const char* section, fcgi_conf* conf);

void fcgi_clear_conf(fcgi_conf* conf);

HFcgi fcgi_create_server(const fcgi_conf* conf);

int fcgi_run_server(HFcgi);

int fcgi_stop_server(HFcgi);

void fcgi_dispose_server(HFcgi);

#ifdef __cplusplus
}
#endif

#endif /* FCGI_SERVER_H_INCLUDED */
